
import java.io.*;
import java.net.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.sql.*;

// servlet for application management.
// param: userID, applName
// the service for "new application", when the appl name exists already, return "0"
// June 27

public class applServ1 extends GenericServlet { 
    static PrintWriter out   = null; // May. 5.

    private String uid      = null;
    private String applName = null;
    private String applID   = null;

    public void service(ServletRequest req, ServletResponse res)
        throws ServletException, IOException
    {
	System.out.println("enter the servlet applServ");
        res.setContentType("text/html");
        out = new PrintWriter(res.getOutputStream());
     
	uid      = req.getParameter("userID");
	applName = req.getParameter("applName");
        String DrepIP  = req.getParameter("DrepIP");
        String DrepPort= req.getParameter("DrepPort");
        String DrepDBA = req.getParameter("DrepDBA");

	System.out.println("uid=" + uid.trim() + " applName=" + applName.trim() + "$$");
	String query1 = "Select ApplID from ApplInfo where UserID='" + uid + "'";
	String query2 = "Select ApplID from ApplInfo where UserID='" + uid.trim() 
			+ "' and ApplName='" + applName.trim() + "'";;

// connect to database
	ResultSet      rs = null;
	int         count = 0;
	String        url = null;
	Connection    con = null;
	Statement sqlstmt = null;
    	try {
		Class.forName("COM.imaginary.sql.msql.MsqlDriver");
//		url = "jdbc:msql://emorgana.cat.syr.edu:4333/VDCE";
//		con = DriverManager.getConnection(url, "demo", "");
                url = "jdbc:msql://" + DrepIP + ":" + DrepPort + "/VDCE";
                con = DriverManager.getConnection(url, DrepDBA, "");

		sqlstmt = con.createStatement();

// check if the applName is used already (exists in the database),
	 	rs = sqlstmt.executeQuery(query2);
System.out.println("SqlStat=" + query2);
		while (rs.next()) {
		    uid = rs.getString(1);
		    count ++;		
		 }
		rs.close();
		sqlstmt.close();
	    }   catch( Exception e ) {
		System.out.println(e.getMessage());
		e.printStackTrace();
	    }
	System.out.println("count=" + count);
	if (count > 0)
	    	out.println("0");
	else {
// try to find a unused number in field ApplID
	   try {
		sqlstmt = con.createStatement();
	 	rs = sqlstmt.executeQuery(query1);
		int rec  = 0;
		while (rs.next()) 
	           rec ++; 
		rs.close();
		sqlstmt.close();
		sqlstmt = con.createStatement();
		rs = sqlstmt.executeQuery(query1);
		int[] appls = new int[rec];
		int i = 0;
		while (rs.next()) {
		    appls[i] = Integer.parseInt(rs.getString(1));
		    i ++;
		 }	    
		rs.close();
		sqlstmt.close();
		int base = 1;
		boolean flag;
		while (true) {
		    flag = false;
		    for (i = 0; i < rec; i ++)
		    if (base == appls[i]) {
			flag = true;
			break;
		     }
		    if (!flag)
		       break; // not exists in current database
		    base ++;
		 }
		applID = Integer.toString(base);
		System.out.println("applID==" + applID);
		out.println(applID);
		con.close();
	    }   catch( Exception e ) {
		System.out.println(e.getMessage());
		e.printStackTrace();
	    }
	 }	// else for valid applName
	System.out.println("Exit From applServ Servlet");
        out.flush();
        out.close();
    }

    public String getServletInfo() {
        return " servlet applServ for application management";
    }
}
